#include <stdio.h>

void print_command()
{
    printf("aiot-modem-control { COMMAND | help }\n");
    printf("COMMANND := {dial | hangup | get-phone-number |\n");
    printf("         get-signal-quality | wwan-force-restart | poweron | poweroff |\n");
    printf("         activate | deactivate | poweroff-and-fin | status }\n");
}

static void print_set_apn()
{
    printf("aiot-modem-control set-apn APN\n");
    printf("APN := ex. \"exsample.com\"\n");
}

static void print_set_sim_slot()
{
    printf("aiot-modem-control set-sim-slot { 1 | 2 }\n");
}

static void print_get_signal_quality()
{
    printf("aiot-modem-control get-signal-quality\n");
    printf("  returns rsrq(reference signal received quality)\n");
    printf("      0: rsrq < -19.5 dB\n");
    printf("      1: -19.5 dB <= rsrq < -19   dB\n");
    printf("      2: -19   dB <= rsrq < -18.5 dB\n");
    printf("    ...\n");
    printf("     32: - 4   dB <= rsrq < - 3.5 dB\n");
    printf("     33: - 3.5 dB <= rsrq < - 3   dB\n");
    printf("     34: - 3   dB <= rsrq\n");
    printf("    255: not known or not detectable\n");
}

static void print_set_psm()
{
    printf("aiot-modem-control set-psm { disable | default }\n");
    printf("  disable: set disable.\n");
    printf("  default: set disable and default.\n");
    printf("\n");
    printf("aiot-modem-control set-psm enable TAU ACTTIME\n");
    printf("  TAU(Periodic TAU cycle T3412)\n");
    printf("  TAU := { 2s | 4s | 6s ... 62s | 90s | 120s |150s ... 930s |\n");
    printf("      1m | 2m | 3m ... 31m | 40m | 50m | 60m ... 310m |\n");
    printf("      1h | 2h | 3h ... 31h | 40h | 50h | 60h ... 310h\n");
    printf("  ACTTIME(Active time T3324\n");
    printf("  ACTTIME := { 2s | 4s | 6s ... 62s |\n");
    printf("          1m | 2m | 3m ... 31m | 36m | 42m | 48m ... 186m\n");
    printf("  s:seconds, m:minutes, h:hours\n");
}

static void print_set_edrx()
{
    printf("aiot-modem-control set-edrx { disable | default }\n");
    printf("  disable: set disable.\n");
    printf("  default: set disable and default.\n");
    printf("\n");
    printf("aiot-modem-control set-edrx enable PCL PTW\n");
    printf("  PCL(Paging Cycle Length) seconds\n");
    printf("  PCL := { 5.12 | 10.24 | 20.48 | 40.96 | 61.44 | 81.92 | 102.4 |\n");
    printf("      122.88 | 143.36 | 163.84 | 327.68 | 655.36 | 1310.72 | 2621.44 }\n");
    printf("  PTW(Paging Time Window eDRX) seconds\n");
    printf("  PTW := { 1.28 | 2.56 | 5.12 | 6.40 | 7.68 | 8.96 | 10.24 | 11.52 |\n");
    printf("      12.80 | 14.08 | 15.36 | 16.64 | 17.92 | 19.20 | 20.48 }\n");
}

static void print_set_suspend()
{
    printf("aiot-modem-control set-suspend { enable | disable }\n");
}

static void print_set_sleep()
{
    printf("aiot-modem-control set-sleep disable\n");
    printf("\n");
    printf("aiot-modem-control set-sleep enable MILLISECONDS\n");
    printf("  MILLISECONDS := {100 ... 5000}\n");
}

static void print_send_at()
{
    printf("aiot-modem-control send-at ATCOMMAND\n");
    printf("  ATCOMMAND := ex. \"AT\", \"AT+COPS=1,2,\\\"12345\\\"\"\n");
    printf("            must be enclosed within double quotation marks.\n");
}

static void print_send_at_echo()
{
    printf("aiot-modem-control send-at-echo ATCOMMAND\n");
    printf("  ATCOMMAND := ex. \"AT\", \"AT+COPS=1,2,\\\"12345\\\"\"\n");
    printf("            must be enclosed within double quotation marks.\n");
}

void print_help()
{
    print_command();
    printf("\n");
    print_set_apn();
    printf("\n");
    print_set_sim_slot();
    printf("\n");
    print_get_signal_quality();
    printf("\n");
    print_set_psm();
    printf("\n");
    print_set_edrx();
    printf("\n");
    print_set_suspend();
    printf("\n");
    print_set_sleep();
    printf("\n");
    print_send_at();
    printf("\n");
    print_send_at_echo();
}
